#include "listnode.h"
#include "bsp.h"
#include "tll.h"


extern int numlistleaves;
extern int numlistpartitions;
extern ListNode* listnode;
extern LinkedList<ListNode> LeafList;
extern LinkedList<ListNode> PartitionList; 

int ListNode::Compare(const ListNode& Node)
{
  if (linkPosition < Node.linkPosition)
    return smaller;
  if (linkPosition > Node.linkPosition)
    return bigger;
  else
    return same;
}

void MakeNodeLists(BSP_node* node)
{
    if (node->leaf == true)
    {
        numlistleaves++;
        listnode = new ListNode;
        listnode->node = node;
        listnode->linkPosition = node->nodeid;
        LeafList.Insert(listnode);
        return;
    }
    else
    {
        if (node->nodeid != 0)
        {
            numlistpartitions++;
            listnode = new ListNode;
            listnode->node = node;
            listnode->linkPosition = node->nodeid;
            PartitionList.Insert(listnode);
        }
    }
    MakeNodeLists(node->frontnode);
    MakeNodeLists(node->backnode);
}

