#include <windows.h>
#include "plane.h"
#include "locmath.h"


PLANE::PLANE()
{
}

PLANE::~PLANE()
{
}

VECTOR GetEdgeIntersection(VECTOR point0, VECTOR point1, PLANE plane, VECTOR pointOnPlane)
{
    VECTOR planeNormal, intersection, temp;
    float numerator, denominator, t;

    // get the splitting planes normal
    planeNormal.x = plane.nx;
    planeNormal.y = plane.ny;
    planeNormal.z = plane.nz;

// find edge intersection:
// intersection = p0 + (p1 - p0) * t
// where t = (planeNormal . (pointOnPlane - p0)) / (planeNormal . (p1 - p0))

    //planeNormal . (pointOnPlane - point0)
    temp.x = pointOnPlane.x - point0.x;
    temp.y = pointOnPlane.y - point0.y;
    temp.z = pointOnPlane.z - point0.z;
    numerator = DotProduct(planeNormal, temp);

    //planeNormal . (point1 - point0)
    temp.x = point1.x - point0.x;
    temp.y = point1.y - point0.y;
    temp.z = point1.z - point0.z;
    denominator = DotProduct(planeNormal, temp);

    if (denominator)
        t = numerator / denominator;
    else
        t = 0.0;

    intersection.x = point0.x + temp.x * t;
    intersection.y = point0.y + temp.y * t;
    intersection.z = point0.z + temp.z * t;

    return intersection;
}

