// Portal Class    by Alan Baylis 2001

#ifndef PortalH
#define PortalH

#include "vector.h"
#include "vertex.h"
#include "polygon.h"
#include "plane.h"

struct BSP_node;

class PORTAL
{
    public:
        PORTAL();
          ~PORTAL();

    int Compare(const PORTAL& Portal);
    int GetMyPosition() const {return linkPosition;}
    void SetMyPosition(int newPosition) {linkPosition = newPosition;}
    int linkPosition;

        VECTOR GetNormal();
        void SetNormal();

        BSP_node* frontleaf;
        BSP_node* backleaf;
        int PortalId;
        int PartitionNodeId;
        unsigned int numVertices;
        unsigned int Texture;
        float Scale[2];
        float Shift[2];
        float Rotate;
        VERTEX* Vertex;
};

PORTAL* CopyPortal(PORTAL* portal);
void CreateLargePortal(POLYGON splittingPolygon, PORTAL* largePortal);
int SplitPortal(PORTAL* portalToSplit, PLANE plane, VECTOR pointOnPlane, PORTAL* front, PORTAL* back);
int SplitPortal(PORTAL* portalToSplit, POLYGON planePolygon, PORTAL* front, PORTAL* back);
void MakePortalList();
int ClassifyPortal(PORTAL* portal, POLYGON planePolygon);
int ClassifyInvertedPortal(PORTAL* portal, POLYGON planePolygon);
void InvertPortal(PORTAL* portal);
void InvertPortals(BSP_node* node);
void AddPortal(PORTAL* thisportal, BSP_node* node);
void AddPortalsToLeaves(BSP_node* root);
int ClipPortalToFrontLeaf(PORTAL* portal);
int ClipPortalToBackLeaf(PORTAL* portal);
void CheckForSinglePortals(BSP_node* node, BSP_node* originalnode, PORTAL* portal, int* flag);
int RemoveExtraPortals(PORTAL* portal);
void FindTruePortals(BSP_node* node);

#endif
