#include <windows.h>
#include "shared.h"
#include "resource.h"


extern int DialogInUse;
extern float lightColor[3];
extern HWND hWnd;
extern HWND hWndStartDlg;
extern char szText[BUFFER_SIZE];
extern char Directory[MAX_PATH];
extern char AppDirectory[MAX_PATH];  // This application's directory
extern char HaloTypeName[MAX_PATH];         // filename and path to the tga images
extern char FireTypeName[MAX_PATH];
extern char SplineFileName[MAX_PATH];  // filename and path to the spline data

HWND hWndOfDlg;
OPENFILENAME ofn;
char CurrentDirectory[MAX_PATH];

// Initialization dialog process
BOOL CALLBACK StartProc(HWND hwnd,UINT Message, WPARAM wParam, LPARAM /*lParam*/)
{
    switch(Message)
    {
        case WM_INITDIALOG:
            hWndStartDlg = hwnd;

            SendDlgItemMessage(hwnd, IDC_DLG_TEXT1, EM_SETLIMITTEXT, (WPARAM)BUFFER_SIZE - 1, (LPARAM)0);

            sprintf(SplineFileName, "%s", AppDirectory);
            strcat(SplineFileName, "\\default.spn");
            SetDlgItemText(hWndStartDlg, IDC_DLG_TEXT1, SplineFileName);
        return TRUE;

        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDCANCEL:
                    EndDialog(hwnd, IDCANCEL);
                return TRUE;

                case IDOK:
                    if (GetDlgItemText(hwnd, IDC_DLG_TEXT1, szText, BUFFER_SIZE))
                        sprintf(SplineFileName, "%s", szText);
                    else
                        return FALSE;
                    EndDialog(hwnd, IDOK);
                return TRUE;

                case IDC_DLG_SETPATH1:
                    sprintf(szText, "%s", SplineFileName);
                    ZeroMemory(&ofn, sizeof(ofn));
                    ofn.lStructSize = sizeof(ofn);
                    ofn.hwndOwner = hWndStartDlg;
                    ofn.lpstrFilter = "Spline Files (*.spn)\0*.spn\0\0";
                    ofn.lpstrFile = szText;
                    ofn.nMaxFile = MAX_PATH;
                    ofn.lpstrInitialDir = AppDirectory;
                    ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
                    ofn.lpstrDefExt = "spn";
                    if(GetOpenFileName(&ofn))
                        SetDlgItemText(hWndStartDlg, IDC_DLG_TEXT1, szText);
                    sprintf(SplineFileName, "%s", szText);
                return TRUE;
            }
        break;
    }
    return FALSE;
}

// Hook function for color common dialog window
UINT APIENTRY ColorDialogHook(HWND hdlg, UINT msg, WPARAM, LPARAM)
{
    switch (msg)
    {
        case WM_INITDIALOG:
        {
            if(DialogInUse == 1)  // Ambient
                SetWindowText(hdlg, "Choose Ambient Color");
            if(DialogInUse == 2)  // Diffuse
                SetWindowText(hdlg, "Choose Diffuse Color");
            if(DialogInUse == 3)  // Specular
                SetWindowText(hdlg, "Choose Specular Color");
            return TRUE;
        }

        default:
            return FALSE;
    }
}

void GetLightColor()
{
    COLORREF colors[16];
    COLORREF colorRGB = RGB(lightColor[0]*255, lightColor[1]*255, lightColor[2]*255);
    CHOOSECOLOR colorDialog;
    memset(&colorDialog,0,sizeof(colorDialog));
    memset(colors,255,sizeof(colors));
    colorDialog.lStructSize = sizeof(CHOOSECOLOR);
    colorDialog.hwndOwner = hWnd;
    colorDialog.rgbResult = colorRGB;
    colorDialog.lpCustColors = colors;
    colorDialog.Flags = CC_FULLOPEN | CC_RGBINIT | CC_ENABLEHOOK;
    colorDialog.lpfnHook = (LPCCHOOKPROC)ColorDialogHook;
    ChooseColor(&colorDialog);
    lightColor[0] = (float)GetRValue(colorDialog.rgbResult)/255;
    lightColor[1] = (float)GetGValue(colorDialog.rgbResult)/255;
    lightColor[2] = (float)GetBValue(colorDialog.rgbResult)/255;
}
